Unit FastText;

{
 Eine Unit zur direkten Ansteuerung des Text-Bildschirms.
 Toll, wa?

 Copyright (c) by Jan Strter 1997.
 All rights reserved.
}

Interface

Const
   { Versionsnummer }
   Ver = 2;
   { Voder- und Hintergrundfarben }
   Black = 0;
   Blue = 1;
   Green = 2;
   Cyan = 3;
   Red = 4;
   Magenta = 5;
   Brown = 6;
   LightGray = 7;
   { Nur Vordergrundfarben }
   DarkGray = 8;
   LightBlue = 9;
   LightGreen = 10;
   LightCyan = 11;
   LightRed = 12;
   LightMagenta = 13;
   Yellow = 14;
   White = 15;

Var
   TBuf: Pointer;             { Zeiger auf Bildschirm/Puffer }
   Attrib: Byte;              { Attribut-Byte (gesetzte Farben) }

Procedure ShowTBuf;
{
  Kopiert den Text-Buffer in den Bildschirmspeicher.
}
Procedure ClearTBuf(zeichen: Char);
{
  berschreibt den Text-Buffer mit ZEICHEN.
}
Procedure ClearWindow(Zeichen: Char);
{
  berschreibt das momentan gesetzte Textfenster mit ZEICHEN.
}
Procedure ScrToBuf(Buf: Pointer);
{
  Kopiert den Inhalt des Bildschirmspeichers in den Speicherbereich BUF.
}
Procedure BufToScreen(Buf: Pointer);
{
  Kopiert 4 KB von BUF in den Bildschirmspeicher.
}
Procedure BufWriting;
{
  Schaltet Bildschirm-Pufferung ein.
}
Procedure ScrWriting;
{
  Schaltet direktes Schreiben in den Bildschirmspeicher ein.
}
Procedure SetColors(FC,BC: Byte);
{
  Setzt Vordergrundfarbe FC und Hintergrundfarbe BC fr nachfolgende
  Zeichen-Operationen.
}
Procedure PutChar(x,y: Integer; Zeichen: Char);
{
  Schreibt ein Zeichen ZEICHEN an Position x/y.
}
Procedure PutString(x,y: Integer; Ausgabe: String);
{
  Schreibt ein String AUSGABE an Position x/y.
}
Procedure BoxDouble(x1,y1,x2,y2: Integer);
{
  Zeichnet einen doppelten Rahmen mit den Eckpunkten (x1/y1) und (x2/y2).
}
Procedure BoxSingle(x1,y1,x2,y2: Integer);
{
  Zeichnet einen einfachen Rahmen mit den Eckpunkten (x1/y1) und (x2/y2).
}
Procedure Bar(x1,y1,x2,y2: Integer; Zeichen: Char);
{
  Fllt den Bereich (x1/y1) bis (x2/y2) mit ZEICHEN.
}
Procedure HorizLine(x1,x2,y: Integer; Zeichen: Char);
{
  Zeichnet eine horizontale Linie von (x1/y) nach (x2/y).
}
Procedure VertLine(y1,y2,x: Integer; Zeichen: Char);
{
  Zeichnet eine vertikale Linie von (x/y1) nach (x/y2).
}
Procedure MakeShadow(x,y: Integer);
{
  Setzt fr das Zeichen an (x/y) die Farbwerte Hellgrau/schwarz.
  Macht daraus also einen "Schatten".
}
Procedure PutBackColor(x,y: Integer; Col: Byte);
{
  Setzt an (x/y) die Hintergrundfarbe COL.
}
Procedure PutForeColor(x,y: Integer; Col: Byte);
{
  Setzt an (x/y) die Vordergrundfarbe COL.
}
Procedure SetWindow(x1,y1,x2,y2: Integer);
{
  Setzt ein Zeichenfenster von (x1/y1) bis (x2/y2).
}
Procedure GetWindow(Var x1,y1,x2,y2: Integer);
{
  Schreibt die Eckkoordianten des gesetzen Textfensters in
  die bergebenen Parameter.
}
Function  UCase(Str: String): String;
{
  Wandelt einen String in Grobuchstaben um.
  Bercksichtigt deutsche Umlaute.
}
Function  LCase(Str: String): String;
{
  Wandelt einen String in Kleinbuchstaben um.
  Bercksichtigt deutsche Umlaute.
}

Implementation

Var
   DummyPtr: Pointer;         { Zeiger auf Text-Buffer }
   ScrSeg  : Word;            { Segment des Bildschirmspeichers }
   w_x1,
   w_x2,
   w_y1,
   w_y2    : Word;            { Koordinaten des Text-Fensters }

Function UCase; Assembler;
Asm
   push  es
   push  ds
   les   di,@Result           { Ziel nach ES:DI laden }
   lds   si,Str               { Quelle nach DS:SI laden }
   mov   cl,ds:[si]           { String-Lnge nach CL laden }
   xor   ch,ch
   inc   si
   mov   es:[di],cl           { Und sofort in Ziel-String kopieren }
   or    cl,cl
   je    @TheEnd
   inc   di
@Loop:
   mov   al,ds:[si]           { Buchstabe lesen }
   cmp   al,97                { Prfen, ob er zwischen 'a' und 'z' liegt }
   jb    @NoConvert
   cmp   al,122
   ja    @NoConvert
   sub   al,32                { 32 abziehen, um Grobuchstaben zu erhalten }
   jmp   @LoopEnd
@NoConvert:
   cmp   al,148               { '' ? }
   jne   @NoOe
   mov   al,153               { In '' konvertieren }
   jmp   @LoopEnd
@NoOe:
   cmp   al,129               { '' ? }
   jne   @NoUe
   mov   al,154               { In '' konvertieren }
   jmp   @LoopEnd
@NoUe:
   cmp   al,132               { '' ? }
   jne   @LoopEnd
   mov   al,142               { In '' konvertieren }
@LoopEnd:
   mov   es:[di],al           { Konvertierten Buchstaben in Ziel-String schreiben }
   inc   di
   inc   si
   dec   cl
   jne   @Loop                { Bis alles abgearbeitet ist }
@TheEnd:
   pop   ds
   pop   es
End;

Function LCase; Assembler;
Asm
   push  es
   push  ds
   les   di,@Result           { Ziel nach ES:DI }
   lds   si,Str               { Quelle entsprechend nach DS:SI }
   mov   cl,ds:[si]           { Lngen-Byte lesen }
   xor   ch,ch
   inc   si
   mov   es:[di],cl           { Und in Ziel unterbringen }
   or    cl,cl
   je    @TheEnd
   inc   di
@Loop:
   mov   al,ds:[si]           { Datenbyte lesen }
   cmp   al,65                { Liegt der Buchstabe zwischen 'A' und 'Z' ? }
   jb    @NoConvert
   cmp   al,90
   ja    @NoConvert
   add   al,32                { 32 addieren, um Grobuchstaben zu erhalten }
   jmp   @LoopEnd
@NoConvert:
   cmp   al,153               { '' ? }
   jne   @NoOe
   mov   al,148               { In '' konvertieren }
   jmp   @LoopEnd
@NoOe:
   cmp   al,154               { '' ? }
   jne   @NoUe
   mov   al,129               { In '' konvertieren }
   jmp   @LoopEnd
@NoUe:
   cmp   al,142               { '' ? }
   jne   @LoopEnd
   mov   al,132               { In '' konvertieren }
@LoopEnd:
   mov   es:[di],al           { Konvertiertes Byte in Ziel-String schreiben }
   inc   di
   inc   si
   dec   cl
   jne   @Loop                { Bis CX = 0 }
@TheEnd:
   pop   ds
   pop   es
End;

Procedure XChange(Var Var1, Var2: Integer);
var
   Dummy: Integer;
Begin
     Dummy:=Var1;
     Var1:=Var2;
     Var2:=Dummy;
End;

Procedure ShowTBuf; Assembler;
Asm
   push  ds                   { Register retten }
   push  es
   mov   ax,scrseg            { Ziel-Adresse laden }
   mov   es,ax
   xor   di,di
   lds   si,TBuf              { Quell-Adresse laden }
   mov   cx,1000              { 1000 DWords kopieren }
   db    66h                  { ja, ich bin schon 'nen Trickser... }
   rep   movsw                { entspr.: MOVSD }
   pop   es                   { Register restaurieren }
   pop   ds
End;

Procedure ClearTBuf; Assembler;
Asm
   push  es
   les   di,TBuf              { Ziel-Adresse nach ES:DI laden }
   mov   cx,1000              { 4 KByte kopieren }
   mov   al,zeichen           { In AL kommt das Zeichen... }
   mov   ah,Attrib            { ...und in AH das Attribut! }
   db    66h                  { Ich liebe diesen Trick! }
   shl   ax,16                { Alles in die obere Hlfte von EAX popeln }
   mov   al,zeichen           { Jetzt nochmal die untere Hlfte laden... }
   mov   ah,Attrib
   db    66h                  { Jawoll! }
   rep   stosw                { Jetzt endlich kopieren! }
   pop   es
End;

Procedure ClearWindow; Assembler;
Var
   Rest: Word;
Asm
   push  es
   les   di,TBuf              { Ziel-Adresse laden und Offset berechnen }
   mov   ax,80
   mul   w_y1
   add   ax,w_x1
   shl   ax,1
   add   di,ax
   mov   bx,w_y2              { Hhe berechnen }
   sub   bx,w_y1
   inc   bx
   mov   cx,w_x2              { Breite berechnen }
   sub   cx,w_x1
   inc   cx
   mov   ax,80                { Zeilen-Rest berechnen }
   sub   ax,cx
   shl   ax,1
   mov   Rest,ax
   mov   al,Zeichen           { AX mit Zeichen- und Attributcode laden }
   mov   ah,Attrib
@Y_Loop:
   push  cx                   { Breite sichern }
   rep   stosw                { Zeile kopieren }
   pop   cx                   { Zeilenbreite restaurieren }
   add   di,Rest              { Rest der Zeile berspringen }
   dec   bx
   jne   @Y_Loop              { Bis alle Zeilen gezeichnet worden sind }
   pop   es
End;

Procedure SetColors; Assembler;
Asm
   mov   al,bc                { Hintergrundfarbe nach AL }
   shl   al,4                 { das ganze 4 Bits nach links schieben }
   add   al,fc                { in die unteren 4 Bit kommt die Vordergrundfarbe }
   mov   attrib,al            { jetzt noch den Kram im RAM unterbringen }
End;

Procedure PutChar; Assembler;
Asm
   push  es
   mov   ax,w_x1              { Das ganze hier sieht wilder aus, als es ist, }
   add   x,ax                 { letzen Endes wird hier nur berprft, ob }
   mov   ax,w_y1              { das nette Zeichen auch im erlaubten Bereich }
   add   y,ax                 { liegt. }
   mov   ax,x
   cmp   ax,w_x1
   jl    @Ende                { In Pascal wrde das etwa heien: }
   cmp   ax,w_x2              { If (x<w_x1) or (x>w_x2) or (y<w_y1) or }
   jg    @Ende                {    (y>w_y2) Then Exit; }
   mov   ax,y
   cmp   ax,w_y1              { Wobei w_x1, w_y1, w_x2 und w_y2 die }
   jl    @Ende                { Koordinaten des Textfensters sind. }
   cmp   ax,w_y2
   jg    @Ende
   les   di,TBuf              { Ziel-Adresse nach ES:DI laden }
   mov   ax,80
   mul   y                    { Offset = ( y * 80 + x ) * 2 }
   add   ax,x
   shl   ax,1
   add   di,ax                { Offset auf DI addieren }
   mov   al,zeichen
   mov   es:[di],al           { ZEICHEN ins erste Byte... }
   mov   al,attrib
   mov   es:[di+1],al         { ... und ATTRIB ins zweite Byte schreiben }
@Ende:
   pop   es
End;

Procedure PutString; Assembler;
Var
   _w_x1, _w_x2: Integer;
   clip_lt, clip_rt: Integer;
Asm
   push  es
   push  ds
   mov   ax,w_x1              { Linke obere Ecke des Fensters }
   add   x,ax                 { dazuaddieren und Prfen, ob im Fenster }
   mov   ax,w_y1
   add   y,ax
   mov   ax,x
   cmp   ax,w_x2
   jg    @Ende
   mov   ax,y
   cmp   ax,w_y1
   jl    @Ende
   cmp   ax,w_y2
   jg    @Ende
   mov   bh,Attrib            { Noch schnell einige Variablen vor }
   mov   ax,w_x1              { dem Verndern von DS umkopieren }
   mov   _w_x1,ax
   mov   ax,w_x2
   mov   _w_x2,ax
   les   di,TBuf              { Quell-Adresse laden und String-Lnge berprfen }
   lds   si,ausgabe
   mov   cl,ds:[si]
   xor   ch,ch
   or    cl,cl
   je    @ende
   xor   ax,ax                { Jetzt den String clippen }
   mov   clip_rt,ax
   mov   clip_lt,ax
   mov   ax,x
   cmp   ax,_w_x1
   jge   @Kein_Clip_Links
   add   ax,cx
   jle   @Ende
   mov   ax,_w_x1
   sub   ax,x
   mov   clip_lt,ax
@Kein_Clip_Links:
   mov   ax,x
   add   ax,cx
   cmp   ax,_w_x2
   jle   @Kein_Clip_Rechts
   sub   ax,_w_x2
   dec   ax
   mov   clip_rt,ax
@Kein_Clip_Rechts:
   mov   ax,clip_lt
   add   x,ax
   add   si,ax
   sub   cx,ax
   mov   ax,clip_rt
   sub   cx,ax
   mov   ax,80                { Zieladresse laden und Offset berechnen }
   mul   y                    { s.o. }
   add   ax,x
   shl   ax,1
   add   di,ax
   inc   si                   { Das Zhlbyte des Strings berspringen }
   mov   ah,bh                { AH mit Attribut laden }
@anfang:
   mov   al,ds:[si]
   mov   es:[di],ax           { Zeichen- und Attribut-Byte kopieren }
   add   di,2
   inc   si
   dec   cx
   jne   @anfang              { solange, bis CX = 0 }
@ende:
   pop   ds
   pop   es
End;

Procedure Bar; Assembler;
Var
   Rest: Word;
Asm
   push  es
   mov   ax,w_x1              { Ersteinmal die linke obere Ecke des }
   add   x1,ax                { Textfensters auf die Koordinaten addieren }
   add   x2,ax
   mov   ax,w_y1
   add   y1,ax
   add   y2,ax
   mov   ax,x1                { Dann ggf. x1/x2 und y1/y2 vertauschen, }
   cmp   ax,x2                { falls die Reihenfolge nicht stimmt }
   jle   @NoSwapX
   xchg  ax,x2
   mov   x1,ax
@NoSwapX:
   mov   ax,y1
   cmp   ax,y2
   jle   @NoSwapY
   xchg  ax,y2
   mov   y1,ax
@NoSwapY:
   mov   ax,x1                { Falls x1 > w_x2, abbrechen }
   cmp   ax,w_x2
   jg    @TheEnd
   cmp   ax,w_x1              { Jetzt ggf. clippen }
   jge   @NoClipLeft          { d.h. falls die Koordinaten zu gro }
   mov   ax,w_x1              { oder zu klein sind, werden sie einfach }
   mov   x1,ax                { auf die richtige Gre gebracht }
@NoClipLeft:
   mov   ax,x2
   cmp   ax,w_x1
   jl    @TheEnd
   cmp   ax,w_x2
   jle   @NoClipRight
   mov   ax,w_x2
   mov   x2,ax
@NoClipRight:
   mov   ax,y1
   cmp   ax,w_y2
   jg    @TheEnd
   cmp   ax,w_y1
   jge   @NoClipUp
   mov   ax,w_y1
   mov   y1,ax
@NoClipUp:
   mov   ax,y2
   cmp   ax,w_y1
   jl    @TheEnd
   cmp   ax,w_y2
   jle   @NoClipDown
   mov   ax,w_y2
   mov   y2,ax
@NoClipDown:
   les   di,TBuf              { Ziel-Adresse nach ES:DI laden }
   mov   ax,80                { Offset nach bekannten Formel berechnen }
   mul   y1
   add   ax,x1
   shl   ax,1
   add   di,ax                { und dazu addieren }
   mov   bx,x2                { Breite berechnen }
   sub   bx,x1
   mov   ax,y2                { Hhe berechnen }
   sub   ax,y1
   mov   dx,ax
   inc   dx                   { noch um 1 erhhen, weil sonst zu kleen }
   je    @TheEnd              { falls 0, Abbruch, da sonst Absturz! }
   inc   bx                   { fr die Breite genauso... }
   je    @TheEnd
   mov   ax,80                { Jetzt noch den Zeilenrest berechnen }
   sub   ax,bx
   shl   ax,1                 { Mal 2, wegen den Attribut-Bytes }
   mov   Rest,ax
@y_loop:
   mov   cx,bx                { Breite in CX laden }
   mov   al,Zeichen           { AX mit Zeichen und Attribut laden }
   mov   ah,attrib
   rep   stosw                { Eine Zeile schreiben }
   add   di,Rest
   dec   dx
   jne   @y_loop              { Bis alle Zeilen gezeichnet worden sind }
@TheEnd:
   pop   es
End;

Procedure MakeShadow; Assembler;
Asm
   push  es
   mov   ax,w_x1              { Linke obere Ecke dazu addieren }
   add   x,ax
   mov   ax,w_y1
   add   y,ax
   mov   ax,x
   cmp   ax,w_x1              { Prfen, ob innerhalb des Textfensters }
   jl    @Ende                { Wenn nicht ---> RAUS! }
   cmp   ax,w_x2
   jg    @Ende
   mov   ax,y
   cmp   ax,w_y1
   jl    @Ende
   cmp   ax,w_y2
   jg    @Ende
   les   di,TBuf              { Ziel-Adresse laden und Offset berechnen }
   mov   ax,80
   mul   y
   add   ax,x
   shl   ax,1
   add   di,ax
   inc   di                   { Ziel noch 1 erhhen, da Attribut-Byte }
   mov   al,8
   mov   es:[di],al           { Attribut-Byte schreiben }
@Ende:
   pop   es
End;

Procedure PutForeColor; Assembler;
Asm
   push  es
   mov   ax,w_x1              { Linke obere Ecke dazu addieren }
   add   x,ax
   mov   ax,w_y1
   add   y,ax
   mov   ax,x
   cmp   ax,w_x1              { Prfen, ob innerhalb des Textfensters }
   jl    @Ende                { Wenn nicht ---> RAUS! }
   cmp   ax,w_x2
   jg    @Ende
   mov   ax,y
   cmp   ax,w_y1
   jl    @Ende
   cmp   ax,w_y2
   jg    @Ende
   les   di,TBuf              { Ziel-Adresse laden und Offset berechnen }
   mov   ax,80
   mul   y
   add   ax,x
   shl   ax,1
   add   di,ax
   inc   di                   { Ziel noch 1 erhhen, da Attribut-Byte }
   mov   ah,es:[di]
   shr   ah,4                 { Alte Vordergrundfarbe rauswerfen }
   shl   ah,4
   mov   al,Col
   shl   al,4                 { Nur fr den Fall, da Schrott drinstand... }
   shr   al,4
   or    al,ah
   mov   es:[di],al
@Ende:
   pop   es
End;

Procedure PutBackColor; Assembler;
Asm
   push  es
   mov   ax,w_x1              { Linke obere Ecke dazu addieren }
   add   x,ax
   mov   ax,w_y1
   add   y,ax
   mov   ax,x
   cmp   ax,w_x1              { Prfen, ob innerhalb des Textfensters }
   jl    @Ende                { Wenn nicht ---> RAUS! }
   cmp   ax,w_x2
   jg    @Ende
   mov   ax,y
   cmp   ax,w_y1
   jl    @Ende
   cmp   ax,w_y2
   jg    @Ende
   les   di,TBuf              { Ziel-Adresse laden und Offset berechnen }
   mov   ax,80
   mul   y
   add   ax,x
   shl   ax,1
   add   di,ax
   inc   di                   { Ziel noch 1 erhhen, da Attribut-Byte }
   mov   ah,es:[di]
   shl   ah,4                 { Alte Hintergrundfarbe rauswerfen }
   shr   ah,4
   mov   al,Col
   shl   al,4
   or    al,ah
   mov   es:[di],al
@Ende:
   pop   es
End;

Procedure ScrToBuf; Assembler;
Asm
   push  ds
   push  es
   les   di,Buf               { Ziel-Adresse nach ES:DI }
   mov   ax,ScrSeg
   mov   ds,ax                { Quell-Adresse nach DS:SI }
   xor   si,si
   mov   cx,1000              { Zhler auf 1000 DWords }
   db    66h                  { Ich spar' mir das Kommentar... }
   rep   movsw                { ACTION! }
   pop   es
   pop   ds
End;

Procedure BufToScreen; Assembler;
Asm
   push  ds
   push  es
   mov   ax,ScrSeg            { Ziel-Adresse nach ES:DI }
   mov   es,ax                { (So langsam wird's langweilig, }
   xor   di,di                {  immer das gleiche!) }
   lds   si,Buf               { Quell-Adresse nach DS:SI }
   mov   cx,1000              { mal wieder 1000 DWords... }
   db    66h                  { Jaaa, jaaaa! }
   rep   movsw                { Na, was wohl? }
   pop   es
   pop   ds
End;

Procedure HorizLine(x1,x2,y: Integer; Zeichen: Char); Assembler;
Asm
   push  es
   mov   ax,w_x1              { Linke obere Ecke dazu addieren }
   add   x1,ax
   add   x2,ax
   mov   ax,w_y1
   add   y,ax
   mov   ax,y                 { Abbrechen, wenn Linie auf Y-Ebene gar nicht }
   cmp   ax,w_y1              { im Fenster ist }
   jl    @TheEnd
   cmp   ax,w_y2
   jg    @TheEnd
   mov   ax,x1                { ggf. x1 und x2 vertauschen }
   cmp   ax,x2
   jle   @NoSwapX
   xchg  ax,x2
   mov   x1,ax
@NoSwapX:
   mov   ax,x1                { Abbrechen, wenn Linie berhaupt nicht }
   cmp   ax,w_x2              { im Bild ist }
   jg    @TheEnd
   mov   ax,x2
   cmp   ax,w_x1
   jl    @TheEnd
   mov   ax,x1                { x-Koordinaten ggf. clippen }
   cmp   ax,w_x1
   jge   @NoClipLeft
   mov   ax,w_x1
   mov   x1,ax
@NoClipLeft:
   mov   ax,x2
   cmp   ax,w_x2
   jle   @NoClipRight
   mov   ax,w_x2
   mov   x2,ax
@NoClipRight:
   mov   cx,x2                { Breite berechnen und in CX laden }
   sub   cx,x1
   inc   cx
   or    cx,cx                { falls Breite = 0, abbrechen }
   je    @TheEnd
   les   di,TBuf              { Ziel-Adresse nach ES:DI laden }
   mov   ax,80
   mul   y
   add   ax,x1
   shl   ax,1
   add   di,ax                { Offset dazu addieren }
   mov   al,Zeichen           { AX mit Daten versorgen }
   mov   ah,Attrib
@X_Loop:
   mov   es:[di],ax           { Wort schreiben }
   add   di,2                 { Offset erhhen }
   dec   cx
   jne   @X_Loop              { bis CX = 0 }
@TheEnd:
   pop   es
End;

Procedure VertLine(y1,y2,x: Integer; Zeichen: Char); Assembler;
Asm
   push  es
   mov   ax,w_x1              { Linke obere Ecke dazu addieren }
   add   x,ax
   mov   ax,w_y1
   add   y1,ax
   add   y2,ax
   mov   ax,x                 { Falls in X-Richtung auerhalb, abbrechen }
   cmp   ax,w_x1
   jl    @TheEnd
   cmp   ax,w_x2
   jg    @TheEnd
   mov   ax,y1                { ggf. y1 und y2 vertauschen }
   cmp   ax,y2
   jle   @NoSwapY
   xchg  ax,y2
   mov   y1,ax
@NoSwapY:
   mov   ax,y1                { Abbrechen, wenn Linie gar nicht zu sehen }
   cmp   ax,w_y2
   jg    @TheEnd
   mov   ax,y2
   cmp   ax,w_y1
   jl    @TheEnd
   mov  ax,y1                 { Jetzt ggf. clippen }
   cmp  ax,w_y1
   jge  @NoClipUp
   mov  ax,w_y1
   mov  y1,ax
@NoClipUp:
   mov  ax,y2
   cmp  ax,w_y2
   jle  @NoClipDown
   mov  ax,w_y2
   mov  y2,ax
@NoClipDown:
   mov  cx,y2                 { Hhe berechnen }
   sub  cx,y1
   inc  cx
   or   cx,cx                 { Abbrechen, wenn hhe Null ist }
   je   @TheEnd
   les  di,TBuf               { Ziel-Adresse laden und Offset berechnen }
   mov  ax,80
   mul  y1
   add  ax,x
   shl  ax,1
   add  di,ax
   mov  al,Zeichen            { AX laden }
   mov  ah,Attrib
@Y_Loop:
   mov  es:[di],ax            { Ein Word kopieren }
   add  di,160                { Restliche Zeile berspringen }
   dec  cx
   jne  @Y_Loop               { bis CX = 0 }
@TheEnd:
   pop   es
End;

Procedure BoxDouble(x1,y1,x2,y2: Integer);
Begin
     { Falls die erste Koordinate grer ist als die zweite, vertauschen }
     If x1 > x2 Then XChange(x1,x2);
     If y1 > y2 Then XChange(y1,y2);

     { Die beiden horizontalen Linien zeichnen }
     HorizLine(x1+1,x2-1,y1,'');
     HorizLine(x1+1,x2-1,y2,'');

     { Die beiden vertikalen Linien zeichnen }
     VertLine(y1+1,y2-1,x1,'');
     VertLine(y1+1,y2-1,x2,'');

     { Und schlielich die Ecken zeichnen }
     PutChar(x1,y1,'');
     PutChar(x2,y1,'');
     PutChar(x1,y2,'');
     PutChar(x2,y2,'');
End;

Procedure BoxSingle(x1,y1,x2,y2: Integer);
Begin
     { Falls die erste Koordinate grer ist als die zweite, vertauschen }
     If x1 > x2 Then XChange(x1,x2);
     If y1 > y2 Then XChange(y1,y2);

     { Die beiden horizontalen Linien zeichnen }
     HorizLine(x1+1,x2-1,y1,'');
     HorizLine(x1+1,x2-1,y2,'');

     { Die beiden vertikalen Linien zeichnen }
     VertLine(y1+1,y2-1,x1,'');
     VertLine(y1+1,y2-1,x2,'');

     { Und schlielich die Ecken zeichnen }
     PutChar(x1,y1,'');
     PutChar(x2,y1,'');
     PutChar(x1,y2,'');
     PutChar(x2,y2,'');
End;

Procedure ColorCheck;
Begin
     If (Mem[$0000:$0410] And $30) <> $30 Then ScrSeg:=$B800 Else ScrSeg:=$B000;
End;

Procedure BufWriting;
Begin
     TBuf:=DummyPtr;
End;

Procedure ScrWriting;
Begin
     TBuf:=Ptr(ScrSeg,$0000);
End;

Procedure SetWindow;
Begin
     { Koordinaten berprfen, ggf. Verndern oder abbrechen }
     If x1 > x2 Then XChange(x1,x2);
     If y1 > y2 Then XChange(y1,y2);
     If x1 >= 79 Then Exit;
     If y1 >= 24 Then Exit;
     If x2 > 79 Then x2:=79;
     If y2 > 24 Then y2:=24;
     { Koordinaten setzen }
     w_x1:=x1;
     w_x2:=x2;
     w_y1:=y1;
     w_y2:=y2;
End;

Procedure GetWindow;
Begin
     x1:=w_x1;
     x2:=w_x2;
     y1:=w_y1;
     y2:=w_y2;
End;

Begin
     GetMem(DummyPtr,4000);
     ColorCheck;
     SetColors(LightGray,Black);
     SetWindow(0,0,79,24);
     BufWriting;
End.